#ifndef _KILIB_FILE_H_
#define _KILIB_FILE_H_
#include "types.h"
#include "memory.h"
#ifndef __ccdoc__
namespace ki {
#endif



//=========================================================================
//@{ @pkg ki.StdLib //@}
//@{
//	ȈՃt@CǍ
//
//	t@C}bsOp̂ŁAȒPłƍłB
//	ƂɁA4GB܂łJ܂B
//@}
//=========================================================================

class FileR : public Object
{
public:

	FileR();
	~FileR();

	//@{
	//	J
	//	@param fname t@C
	//	@return Jǂ
	//@}
	bool Open( const TCHAR* fname );

	//@{
	//	
	//@}
	void Close();

public:

	//@{ t@CTCY //@}
	ulong size() const;

	//@{ t@Ce}bvAhX擾 //@}
	const uchar* base() const;

private:

	HANDLE      handle_;
	HANDLE      fmo_;
	ulong       size_;
	const void* basePtr_;

private:

	NOCOPY(FileR);
};



//-------------------------------------------------------------------------

inline ulong FileR::size() const
	{ return size_; }

inline const uchar* FileR::base() const
	{ return static_cast<const uchar*>(basePtr_); }



//=========================================================================

}      // namespace ki
#endif // _KILIB_FILE_H_
